<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Document</title>
</head>

<body>
    <script>
        /*
        Напишите функцию, которая принимает в
        себя 2 объекта - резюме и вакансию,
         и возвращает процент совпадения требуемых навыков (скиллов).
        Навык совпадает если имя скилла совпадает с имененм
        в вакансии и и требуемый опыт <= опыту человека в этом навыке
        */

        const resume = {
            name: "Илья",
            lastName: "Куликов",
            age: 29,
            city: "Киев",
            skills: [
                {
                    name: "Vanilla JS",
                    practice: 5
                },
                {
                    name: "ES6",
                    practice: 3
                },
                {
                    name: "React + Redux",
                    practice: 1
                },
                {
                    name: "HTML5",
                    practice: 6
                },
                {
                    name: "CSS3",
                    practice: 6
                }
            ]
        };

        const resume2 = {
            name: "Петр",
            lastName: "Петров",
            age: 18,
            city: "Иваново",
            skills: [
                {
                    name: "Vanilla JS",
                    practice: 1
                },
                {
                    name: "ES5",
                    practice: 2
                },
                {
                    name: "Vue.js",
                    practice: 1
                },
                {
                    name: "HTML4",
                    practice: 10
                },
                {
                    name: "CSS2",
                    practice: 10
                },
                {
                    name: "Webpack",
                    practice: 1
                }
            ]
        };


        const vacancy = {
            company: "SoftServe",
            location: "Киев",
            skills: [
                {
                    name: "Vanilla JS",
                    experience: 3
                },
                {
                    name: "ES6",
                    experience: 2
                },
                {
                    name: "React + Redux",
                    experience: 2
                },
                {
                    name: "HTML4",
                    experience: 2
                },
                {
                    name: "CSS2",
                    experience: 2
                },
                {
                    name: "HTML5",
                    experience: 2
                },
                {
                    name: "CSS3",
                    experience: 2
                },
                {
                    name: "AJAX",
                    experience: 2
                },
                {
                    name: "Webpack",
                    experience: 2
                }
            ]
        };


        const matchesItems = (resumeArr, vacancyArr) => {
            const matchedItem = resumeArr.reduce((prev, {name: employeeSkill,  practice}) => {
               const skill =  vacancyArr.find(({name}) => name === employeeSkill);
               if (!skill){
                   return prev;
               }
              return [...prev, practice >= skill.experience];





            // let count = 0;
            // resumeArr.forEach(({name: employeeSkill,  practice }) => {
            //     if (vacancyArr.find(({name, experience}) =>
            //         name === employeeSkill && practice >= experience)){
            //         count++;
            //     }
            // });
            // return count;
        }, []);
            return  matchedItem.length;

        };

        const percentEvaluation  = (current, general) => Math.round((current / general) * 100);

        const vacancyPercentage = ({skills: resumeSkillsArr}, {skills: vacancySkillsArr}) => {
            const matches = matchesItems(resumeSkillsArr, vacancySkillsArr);
            const matchPercent = percentEvaluation(matches, vacancySkillsArr.length);
            console.log(`This profile match on ${matchPercent}% with current vacancy`);


        };


        vacancyPercentage(resume2, vacancy);


    </script>
</body>

</html>
